import socket
import struct
import time
import numpy as np
#import errno

#ip = "10.99.43.186" # IP of Raspberry Pi outside lab

def ReadPD_pi(channel):
    ip = "192.168.1.241" # IP of RP inside lab

    # connect to server
    client = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    client.connect((ip, 8080))
    msg = str(channel)
    client.send(msg.encode())
    from_server = client.recv(4096)
    client.close()
    return float(struct.unpack('<f',from_server)[0]) 

def ReadPD_average_pi(channel, N, sleeptime=0.01):
    measures = []
    for j in range(N):
        #try:
        measures.append(ReadPD_pi(channel))
        #except errno.ECONNRESET as e:
        #except:
        #    print('lio1')
        time.sleep(sleeptime)
    if len(measures) != 0:
        return np.mean(np.array(measures))
    else:
        print("lio2")
        ReadPD_average_pi(channel, N)


if __name__ == "__main__":
    import matplotlib.pyplot as plt

    """    
    MeanReadVector = []
    for j in range(30):
        ReadVector = []
        for i in range(10):
            value = ReadPD_pi(0)
            ReadVector.append(value)
            time.sleep(0.02)
        MeanReadVector.append(np.mean(ReadVector))
        print(j)
    plt.hist(MeanReadVector)
    """
    vector = []
    for j in range(20):
        vector.append(ReadPD_average_pi(0, 5))
    plt.hist(vector)
    
    
    